﻿#define DO_IT_IN_PARALLEL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ClassConstructorsAndThreadSafety {
	class Program {
		static Program() {
			Console.WriteLine("Program.cctor: Initilizing class ...");

#if !DO_IT_IN_PARALLEL
			InitializePart1();
#else
			var t = new Thread(InitializePart1);
			t.Start();		// Initialize part 1 in parallel with part 2 below
			
			// Initilize part 2 of Program class
			// ...
			// Done

			t.Join();
#endif
		}

		static void InitializePart1() {
			// ...
		}

		static void Main(string[] args) {
			Console.WriteLine("Program.Main: I'm here!");
		}
	}
}
